]> git.pld-linux.org Git - packages/rpm.git/blob - rpm.macros
- fix parse error for %__kernel_ver if no kernel source installed, simplify it too
[packages/rpm.git] / rpm.macros
1 # $Revision$, $Date$
2 # PLD Linux rpm macros
3
4 %epoch          0
5 %x8664          x86_64 amd64 ia32e
6
7 # kernel compiler
8 %kgcc           %{__cc}
9 %kgcc_package   gcc
10
11 %__rm                   /bin/rm --interactive=never
12
13 # Build system path macros.
14 #
15 %__autoconf             autoconf %{?debug:-Wall}
16 %__automake             automake -a -c -f --foreign
17 %__autopoint            autopoint --force
18
19 %__gettextize { \
20         if grep -qs 'AM_GNU_GETTEXT.*external' configure.{ac,in} ; then \
21                 gettextize --copy --force --no-changelog; \
22         else \
23                 gettextize --copy --force --no-changelog --intl; \
24         fi; \
25         if [ ! -f po/Makevars ]; then \
26                 cp -f po/Makevars{.template,}; \
27         fi; \
28 }
29
30 %__glib_gettextize      glib-gettextize --copy --force
31 %__gnome_doc_common     gnome-doc-common --copy
32 %__gnome_doc_prepare    gnome-doc-prepare --copy --force
33 %__gtkdocize            gtkdocize --copy
34 %__intltoolize          intltoolize --copy --force
35 %__libtoolize           libtoolize --copy --force
36
37 #       Path to top of build area.
38 %_topdir                %{expand:%%global _topdir %(test -d ../SPECS -a -d ../SOURCES && (cd ..; pwd) || echo $HOME/rpm)}%_topdir
39
40 #       The number of cvs changelog entries kept when building package.
41 %_buildchangelogtruncate 20
42
43 %dependencytracking     %{nil}
44
45 #       Relations between package names that cause dependency loops
46 #       with legacy packages that cannot be fixed. Relations are
47 #       specified as
48 #               p>q
49 #       where package p has a Requires: on something that package q Provides:
50 #
51 # XXX   Note: that there cannot be any whitespace within the string "p>q",
52 #       and that both p and q are package names (i.e. no version/release).
53 %_dependency_whiteout   %{nil}
54
55 %_smp_mflags %([ -z "$RPM_BUILD_NCPUS" ] \\\
56         && RPM_BUILD_NCPUS="`/usr/bin/getconf _NPROCESSORS_ONLN`"; \\\
57         [ "$RPM_BUILD_NCPUS" -gt 1 ] && echo "-j$RPM_BUILD_NCPUS")
58
59 #-----------------------------------------------------------------
60 #
61 # (re)definition of %{rpm*flags} with %filterout_* support
62 # BuildRequires:        awk
63 # BuildRequires:        rpmbuild(macros) >= 1.315
64 #
65 # Flags specified in %filterout_* are removed from %rpm*flags, exactly:
66 # %rpmcflags    = %optflags - %filterout - %filterout_c   - %filterout_ld
67 # %rpmcxxflags  = %optflags - %filterout - %filterout_cxx - %filterout_ld
68 # %rpmldflags   = %optldflags - %filterout_ld
69 #
70 # Regular expressions are supported, but to avoid some character be treated
71 # as regular expression it must be escaped twice.
72
73 %filter_out                                             \
74         for (i = 1; i in I; i++) {      A=0;    \
75                 for (f in F) {                          \
76                         if (I[i] ~ "^" F[f] "$") A=1;   \
77                 };                                                      \
78                 if (!A) printf(I[i] FS);        \
79         }
80
81 %rpmcflags %(awk 'BEGIN {
82         split("%{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}",I);
83         split("%{?filterout} %{?filterout_c} %{?filterout_ld}",F);
84         %{filter_out}
85 }')
86
87 %rpmcxxflags %(awk 'BEGIN {
88         split("%{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}",I);
89         split("%{?filterout} %{?filterout_cxx} %{?filterout_ld}",F);
90         %{filter_out}
91 }')
92
93 %rpmldflags %(awk 'BEGIN {
94         split("%{?optldflags}",I);
95         split("%{?filterout_ld}",F)
96         %{filter_out}
97 }')
98
99 # rpmldflags with stripped -Wl, -- in the form flags have to be passed to 'ld'
100 # but, don't use it, better use gcc as linker
101 %ld_rpmldflags %(awk 'BEGIN {
102         split("%{rpmldflags}",F);
103         for (f in F) {
104                 s = F[f];
105                 if (s ~ /^-Wl,/) {
106                         s = substr(s,5);
107                         gsub(/,/," ",s);
108                 };
109                 printf(s FS);
110         };
111 }')
112
113 #-----------------------------------------------------------------
114 %configure2_13 { \
115  if [ -n "$LINGUAS" ]; then unset LINGUAS; fi; \
116  LDFLAGS="${LDFLAGS:-%rpmldflags}" ; export LDFLAGS ; \
117  CFLAGS="${CFLAGS:-%rpmcflags}" ; export CFLAGS ; \
118  CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" ; export CXXFLAGS ; \
119  FFLAGS="${FFLAGS:-%rpmcflags}" ; export FFLAGS ; \
120  FCFLAGS="${FCFLAGS:-%rpmcflags}" ; export FCFLAGS ; \
121  CPPFLAGS="${CPPFLAGS:-}" ; export CPPFLAGS ; \
122  %{?__cc:CC="%{__cc}" ; export CC ; } \
123  %{?__cxx:CXX="%{__cxx}" ; export CXX ; } \
124  %{?configuredir:%{configuredir}}%{!?configuredir:.}/configure \
125         --host=%{_target_platform} \
126         --prefix=%{_prefix} \
127         --exec-prefix=%{_exec_prefix} \
128         --bindir=%{_bindir} \
129         --sbindir=%{_sbindir} \
130         --sysconfdir=%{_sysconfdir} \
131         --datadir=%{_datadir} \
132         --includedir=%{_includedir} \
133         --libdir=%{_libdir} \
134         --libexecdir=%{_libexecdir} \
135         --localstatedir=%{_localstatedir} \
136         --sharedstatedir=%{_sharedstatedir} \
137         --mandir=%{_mandir} \
138         --infodir=%{_infodir} \
139         --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
140         %{dependencytracking} \
141 }
142
143 # override __cmake to add -j4 in your ~/.rpmmacros for parallel make
144 %__cmake        /usr/bin/cmake
145 %cmake { \
146 CC="%{__cc}" \
147 CXX="%{__cxx}" \
148 CFLAGS="%{rpmcflags}" \
149 CXXFLAGS="%{rpmcxxflags}" \
150 %{__cmake} \
151 }
152
153 # override __scons to add -j4 in your ~/.rpmmacros for parallel make
154 %__scons        /usr/bin/scons
155 %scons { \
156 %{__scons} \
157         LDFLAGS="${LDFLAGS:-%rpmldflags}" \
158         CFLAGS="${CFLAGS:-%rpmcflags}" \
159         CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" \
160         FFLAGS="${FFLAGS:-%rpmcflags}" \
161         CPPFLAGS="${CPPFLAGS:-}" \
162         %{?__cc:CC="%{__cc}"} \
163         %{?__cxx:CXX="%{__cxx}"} \
164         libsuffix=%{_lib} \
165         prefix=%{_prefix} \
166 }
167
168 # waf. see waf.spec
169 # override __waf to add -j4 in your ~/.rpmmacros for parallel make
170 %__waf  /usr/bin/waf
171 %waf { \
172 CC="%{__cc}" \
173 CXX="%{__cxx}" \
174 CPP="%{__cpp}" \
175 CFLAGS="%{rpmcflags}" \
176 CXXFLAGS="%{rpmcxxflags}" \
177 %{__waf} \
178 }
179
180 #----------------------------------------------------------------
181 #%configure_cache 0
182 %configure_cache_file   %{buildroot}.configure.cache
183
184 %configure {./configure \
185         LDFLAGS="${LDFLAGS:-%rpmldflags}" \
186         CFLAGS="${CFLAGS:-%rpmcflags}" \
187         CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" \
188         FFLAGS="${FFLAGS:-%rpmcflags}" \
189         FCFLAGS="${FCFLAGS:-%rpmcflags}" \
190         CPPFLAGS="${CPPFLAGS:-}" \
191         %{?__cc:CC="%{__cc}"} \
192         %{?__cxx:CXX="%{__cxx}"} \
193         --host=%{_target_platform} \
194         --build=%{_target_platform} \
195         --prefix=%{_prefix} \
196         --exec-prefix=%{_exec_prefix} \
197         --bindir=%{_bindir} \
198         --sbindir=%{_sbindir} \
199         --sysconfdir=%{_sysconfdir} \
200         --datadir=%{_datadir} \
201         --includedir=%{_includedir} \
202         --libdir=%{_libdir} \
203         --libexecdir=%{_libexecdir} \
204         --localstatedir=%{_localstatedir} \
205         --sharedstatedir=%{_sharedstatedir} \
206         --mandir=%{_mandir} \
207         --infodir=%{_infodir} \
208         --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
209         %{dependencytracking} \
210         %{?configure_cache:--cache-file=%{configure_cache_file}} \
211 }
212
213 # overload to insert debuginfo package
214 %prep \
215 %if 0%{?_enable_debug_packages}\
216 %{debug_package}\
217 %endif\
218 %%prep\
219 %{nil}
220
221 # Location of autoconf macros
222 %_aclocaldir    %{expand:%%global _aclocaldir %(aclocal --print-ac-dir || echo ERROR)}%_aclocaldir
223
224 # Location of omf files
225 %_omf_dest_dir  %{expand:%%global _omf_dest_dir %(scrollkeeper-config --omfdir || echo ERROR)}%_omf_dest_dir
226
227 # Location of pkgconfig files
228 %_pkgconfigdir  /usr/%{_lib}/pkgconfig
229 # noarch pkgconfig files
230 %_npkgconfigdir /usr/share/pkgconfig
231
232 # Location of desktop files
233 %_desktopdir    /usr/share/applications
234 %_applnkdir     ERROR:_applnkdir_is_obsolete_use_desktopdir_instead
235
236 # Location of pixmaps for applnk/desktop files
237 %_pixmapsdir    /usr/share/pixmaps
238
239 # Location of themable icons for applnk/desktop files
240 %_iconsdir      /usr/share/icons
241
242 # Location of fonts directories
243 %_fontsdir      /usr/share/fonts
244
245 # Location of Gtk and associated libraries documentation
246 %_gtkdocdir     %{_defaultdocdir}/gtk-doc/html
247
248 # Location of KDE documentation
249 %_kdedocdir     %{_defaultdocdir}/kde/HTML
250
251 # unsermake script
252 %__unsermake /usr/share/unsermake/unsermake
253
254 # Current date
255 %date           %(LC_ALL="C" date +"%a %b %d %Y")
256
257 # Example files, programs, scripts...
258 %_examplesdir   /usr/src/examples
259
260 # Alternative kernel type/version
261 %_alt_kernel    %{nil}%{?alt_kernel:-%{?alt_kernel}}
262
263 # The directory holding Linux kernel sources
264 %_kernelsrcdir  /usr/src/linux%{_alt_kernel}
265
266 # If non-empty "debug" macro defined, add "dbg" suffix to release number
267 %_rpmfilename           %%{NAME}-%%{VERSION}-%%{RELEASE}%{?debug:dbg}.%%{ARCH}.rpm
268
269 # Requires name = version-release
270 %requires_releq()               %(echo '%*' | LC_ALL="C" xargs -r rpm -q --qf 'Requires: %{N} = %|E?{%{E}:}|%{V}-%{R}\\n' | grep -v 'is not')
271
272 %releq_kernel                   %{expand:%%global releq_kernel %(R=$(LC_ALL=C rpm -q --qf '%{N} = %|E?{%{E}:}|%{V}-%{R}' -f %{_kernelsrcdir}/include/linux/version.h 2>/dev/null | grep -v 'is not' | sed -e 's:-headers::;s:-config::'); echo ${R:-ERROR})}%releq_kernel
273 %releq_kernel_up                %{expand:%%global releq_kernel_up %(R=$(LC_ALL=C rpm -q --qf '%{N}-up = %|E?{%{E}:}|%{V}-%{R}' -f %{_kernelsrcdir}/include/linux/version.h 2>/dev/null | grep -v 'is not' | sed -e 's:-headers::;s:-config::'); echo ${R:-ERROR})}%releq_kernel_up
274 %releq_kernel_smp()             %{expand:%%global releq_kernel_smp %(R=$(LC_ALL=C rpm -q --qf '%{N}-smp = %|E?{%{E}:}|%{V}-%{R}' -f %{_kernelsrcdir}/include/linux/version.h 2>/dev/null | grep -v 'is not' | sed -e 's:-headers::;s:-config::'); echo ${R:-ERROR})}%releq_kernel_smp
275 %requires_releq_kernel(s:)              Requires%{-s:(%{-s*})}: %releq_kernel
276 %requires_releq_kernel_up(s:)   Requires%{-s:(%{-s*})}: %releq_kernel_up
277 %requires_releq_kernel_smp(s:)  Requires%{-s:(%{-s*})}: %releq_kernel_smp
278
279 # XXX: why epoch 0 is stripped?
280 %requires_eq()          %(echo '%*' | LC_ALL="C" xargs -r rpm -q --qf 'Requires: %{N} = %|E?{%{E}:}|%{V}\\n' | sed -e 's/ 0:/ /' | grep -v 'is not')
281 %requires_eq_to() %(LC_ALL="C" rpm -q --qf 'Requires: %1 = %|E?{%{E}:}|%{V}' %2 | grep -v "is not")
282
283 %apache_modules_api %{expand:%%global apache_modules_api %(awk '/#define MODULE_MAGIC_NUMBER_MAJOR/ {print $3}' /usr/include/apache/ap_mmn.h 2>/dev/null || echo ERROR)}%apache_modules_api
284
285 # kernel version-release handling
286 %__kernel_ver    %{expand:%%global __kernel_ver %(
287         Z=$(awk -F'"' '/UTS_RELEASE/{print $2}' %{_kernelsrcdir}/include/linux/{version,utsrelease}.h 2>/dev/null); \
288         Z=${Z:-$(awk -F' = ' '/^VERSION/{v=$2} /^PATCHLEVEL/{p=$2} /^SUBLEVEL/{s=$2} /^EXTRAVERSION/{e=$2} END {printf("%d.%d.%d%s", v, p, s, e)}' %{_kernelsrcdir}/Makefile 2>/dev/null)}; \
289         echo ${Z:-ERROR}; \
290 )}%__kernel_ver
291 %__kernel_rel   %{expand:%%global __kernel_rel %(Z=$(LC_ALL=C rpm -qf %{_kernelsrcdir}/include/linux/fs.h 2>/dev/null --qf "%{R}" | grep -v "is not"); echo ${Z:-ERROR})}%__kernel_rel
292 %__kernel_rpmvr %{expand:%%global __kernel_rpmvr %(Z=$(LC_ALL=C rpm -qf %{_kernelsrcdir}/include/linux/fs.h 2>/dev/null --qf "%{V}-%{R}" | grep -v "is not"); echo ${Z:-ERROR})}%__kernel_rpmvr
293 %_kernel_ver    %{expand:%%global _kernel_ver %{__kernel_ver}%{?with_dist_kernel:%(echo %{__kernel_ver} | grep -q -e - || echo -%{__kernel_rel})}}%_kernel_ver
294 %_kernel_ver_str %{expand:%%global _kernel_ver_str %(echo %{!?_without_dist_kernel:%{__kernel_rpmvr}}%{?_without_dist_kernel:%{__kernel_ver}} | sed -e 's/-/_/g')}%_kernel_ver_str
295
296 # sgml macros
297 %xmlcat_add()           /usr/bin/xmlcatalog --noout --add nextCatalog \"\" %1 /etc/xml/catalog ;
298 %xmlcat_del()           /usr/bin/xmlcatalog --noout --del %1 /etc/xml/catalog ;
299 %xmlcat_add_rewrite     /usr/bin/xmlcatalog --noout --add rewriteSystem
300 %xmlcat_create()        /usr/bin/xmlcatalog --noout --create %1 ;
301 %sgmlcat_add()          /usr/bin/install-catalog --add %1 %2 > /dev/null ;
302 %sgmlcat_del()          /usr/bin/install-catalog --remove %1 %2 > /dev/null ;
303 %docbook_sgmlcat_fix() { for l in \
304 '' \
305 '  -- default decl --' \
306 'DTDDECL "-//OASIS//DTD DocBook XML V%2//EN" "../../xml.dcl"' \
307 '  -- hacks for opensp --' \
308 'SYSTEM "file://%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd" "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
309 'SYSTEM "http://www.oasis-open.org/docbook/xml/%2/docbookx.dtd"                  "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
310 '' \
311 ; do echo $l; done >> %1 \
312 }
313
314 # vim - "
315
316 # minimum file size needed for compressed documents.
317 # just smaller files than this get larger when compressed.
318 # some stats:
319 # - 0 byte file compressed was 25 bytes .gz
320 # - 39 byte file was compressed as 57
321 # - with test/test.spec@man 158 byte file was compressed also 158
322 %_min_compress_bytes    159
323
324 #-----------------------------------------------------------------
325 # find and gzip all files in %{_mandir} and %{infodir}
326 #
327 # Requires: xargs, find
328 #
329 #%no_install_post_compress_docs 1
330 %__spec_install_post_compress_docs { \
331 %{!?no_install_post_compress_docs:__spec_install_post_compress_docs() { \
332         for i in /usr/share/man /usr/X11R6/man; do \
333                 if [ -d "$RPM_BUILD_ROOT$i" ]; then \
334                         echo "Compress man pages: $i"; \
335                         find "$RPM_BUILD_ROOT$i" -name '*.bz2' -print | xargs -r %{__bzip2} -df; \
336                         find "$RPM_BUILD_ROOT$i" -name '*.gz' -print | xargs -r %{__gzip} -dnf; \
337                         find $RPM_BUILD_ROOT$i -type l | while read a; do \
338                                 m=$(readlink $a); \
339                                 rm -f $a; \
340                                 echo .so ${m##*/} > $a; \
341                                 echo >&2 "Converted ${a#$RPM_BUILD_ROOT} from symlink to man link: ${m##*/}"; \
342                         done; \
343                         find "$RPM_BUILD_ROOT$i" -type f -size +%{_min_compress_bytes}c -print | xargs -r %{__gzip} -9nf; \
344                 fi; \
345         done; \
346         if [ -d "$RPM_BUILD_ROOT%{_infodir}" ]; then \
347                 echo "Compress info pages: %{_infodir}"; \
348                 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.bz2' -print | xargs -r %{__bzip2} -df; \
349                 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.gz' -print | xargs -r %{__gzip} -dnf; \
350                 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.info*' -type f -size +%{_min_compress_bytes}c -print | xargs -r %{__gzip} -9nf; \
351         fi; \
352 }; __spec_install_post_compress_docs } }
353
354 #-----------------------------------------------------------------
355 # Strip executable binaries and shared object files
356 #
357 # Requires: find, awk, strip, cut, xargs
358 #
359 # Special macros which affect this process:
360 #%no_install_post_strip 1               # disable stripping at all
361 #%_noautostrip                  regexp  # exclude files matching (anchored!) regex from stripping
362 #%_autostripall                 regexp  # strip files matching (anchored!) regex using plain strip
363 #%_autostripunneeded    regexp  # strip files matching (anchored!) regex using strip --strip-unneeded
364 #%_autostripdebug               regexp  # strip files matching (anchored!) regex using strip --strip-debug
365 #
366 %__spec_install_post_strip {%{!?debug: \
367 %{!?no_install_post_strip:__spec_install_post_strip() { \
368 if [ -d "$RPM_BUILD_ROOT" ]; then \
369         if [ -d $RPM_BUILD_ROOT/lib/modules ]; then \
370                 modulelist=$(find $RPM_BUILD_ROOT/lib/modules -name '*o' -type f -print); \
371                 if [ "$modulelist" ]; then \
372                         modulecount=$(echo "$modulelist" | wc -l); \
373                         printf "Stripping %d kernel modules..." $modulecount; \
374                         echo "$modulelist" | xargs -l512 chmod u+w; \
375                         echo "$modulelist" | xargs -l512 %{__strip} --strip-unneeded --remove-section=.comment --remove-section=.note.GNU-stack; \
376                         echo "DONE"; \
377                 fi; \
378         fi; \
379         filelist=$(find $RPM_BUILD_ROOT -type f ! -regex ".*/usr/lib[0-9]*/debug/.*\.debug" ! -regex ".*/lib/modules/.*" ! -regex ".*%{_docdir}/.*" ! -regex ".*%{_includedir}/.*" %{?_noautostrip:! -regex "%{_noautostrip}"} %{?_autostripall:! -regex "%{_autostripall}"} %{?_autostripunneeded:! -regex "%{_autostripunneeded}"} %{?_autostripdebug:! -regex "%{_autostripdebug}"}); \
380         if [ -n "$filelist" ]; then \
381                 filetypes=`echo "$filelist" | xargs -r -d'\\n' file`; \
382                 elfexelist=`echo "$filetypes" | awk -F: '/ELF.*executable/ {print $1}'`; \
383                 elfsharedlist=`echo "$filetypes" | awk -F: '/LF.*shared object/ {print $1}'`; \
384                 archiveslist=`echo "$filetypes" | awk -F: '/current ar archive/ {print $1}'`; \
385                 if [ -n "$elfexelist" ]; then \
386                         printf "Stripping %d ELF executables..." $(echo "$elfexelist" | wc -l); \
387                         chmod u+w $elfexelist; \
388                         %{__strip} --remove-section=.note --remove-section=.comment $elfexelist; \
389                         echo "DONE"; \
390                 fi; \
391                 if [ -n "$elfsharedlist" ]; then \
392                         printf "Stripping %d ELF shared libraries..." $(echo "$elfsharedlist" | wc -l); \
393                         chmod u+w $elfsharedlist; \
394                         %{__strip} --strip-unneeded --remove-section=.note --remove-section=.comment $elfsharedlist; \
395                         echo "DONE"; \
396                 fi; \
397                 if [ -n "$archiveslist" ]; then \
398                         printf "Stripping %d ar archives..." $(echo "$archiveslist" | wc -l); \
399                         chmod u+w $archiveslist; \
400                         %{__strip} --strip-debug --remove-section=.note --remove-section=.comment $archiveslist; \
401                         echo "DONE"; \
402                 fi; \
403         fi; \
404     filelist_all=%{?_autostripall:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripall}")}; \
405     filelist_unneeded=%{?_autostripunneeded:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripunneeded}")}; \
406     filelist_debug=%{?_autostripdebug:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripdebug}")}; \
407         if [ -n "$filelist_all" ]; then \
408                 printf "Stripping everything from %d additional files..." $(echo "$filelist_all" | wc -l); \
409                 chmod u+w $filelist_all; \
410                 %{__strip} --remove-section=.note --remove-section=.comment $filelist_all; \
411                 echo "DONE"; \
412         fi; \
413         if [ -n "$filelist_unneeded" ]; then \
414                 printf "Stripping unneeded from %d additional files..." $(echo "$filelist_unneeded" | wc -l); \
415                 chmod u+w $filelist_unneeded; \
416                 %{__strip} --strip-unneeded --remove-section=.note --remove-section=.comment $filelist_unneeded; \
417                 echo "DONE"; \
418         fi; \
419         if [ -n "$filelist_debug" ]; then \
420                 printf "Stripping debuginfo from %d additional files..." $(echo "$filelist_debug" | wc -l); \
421                 chmod u+w $filelist_debug; \
422                 %{__strip} --strip-debug --remove-section=.note --remove-section=.comment $filelist_debug; \
423                 echo "DONE"; \
424         fi; \
425 fi; }; __spec_install_post_strip } } }
426
427 #-----------------------------------------------------------------
428 # remove all RPATH from executable binaries and shared object files
429 #
430 # Requires: find, awk, cut, xargs, chrpath, uname
431 #
432 # Special macros which affect this process
433 #%no_install_post_chrpath       1       # disable chrpath at all
434 #%_noautochrpath        regex           # exclude files matching (anchored!) regex from chrpath
435 #
436 %__spec_install_post_chrpath {%{!?debug: \
437 %{!?no_install_post_chrpath: __spec_install_post_chrpath() { \
438 if [ -d "$RPM_BUILD_ROOT" ]; then \
439         files=`find $RPM_BUILD_ROOT -type f ! -regex ".*ld-[0-9.]*so.*" ! -regex ".*/usr/lib[0-9]*/debug/.*" ! -regex ".*/lib/modules/.*" ! -regex ".*%{_docdir}/.*" ! -regex ".*%{_includedir}/.*" %{?_noautochrpath:! -regex "%{_noautochrpath}"}`; \
440         if [ -n "$files" ]; then \
441                 objs=`echo "$files" | xargs -r -d'\\n' file | awk -F: '/ELF.*(executable.*dynamically linked|shared object)/ {print $1}'`; \
442         fi; \
443         if [ -n "$objs" ]; then \
444                 printf "Remove RPATH from %d executable binaries and shared object files.\n" $(echo "$objs" | wc -l); \
445                 echo "$objs" | \
446                 while read file; do \
447                         rpath= ; \
448                         chmod u+w "$file"; \
449                         for dir in `chrpath -l "$file" | \
450                                         awk '/RPATH=/ { gsub(/.*RPATH=/,""); gsub(/:/," "); print $0 }'` ; do \
451                                         case $dir in \
452                                         /home/* | /tmp/* | /usr/lib | /usr/lib64 | /lib | /lib64 | /usr/local/lib | /usr/local/lib64 | /usr/X11R6/lib | /usr/X11R6/lib64 ) \
453                                                 echo "remove-rpath: $dir in $file"; \
454                                                 ;; \
455                                         * ) \
456                                                 if [ "$rpath" = "" ] ; then rpath="$dir" ; \
457                                                 else rpath="$rpath:$dir" ; fi ; \
458                                                 ;; \
459                                         esac ; \
460                         done ; \
461                         if [ "$rpath" = "" ] ; then chrpath -d "$file" > /dev/null ; \
462                         else chrpath -r "$rpath" "$file" > /dev/null ; fi ; \
463                 done; \
464         fi; \
465 fi; }; __spec_install_post_chrpath } } }
466
467 #-----------------------------------------------------------------
468 # Find and gzip all kernel modules
469 #
470 # Requires: find
471 #
472 #%no_install_post_compress_modules      1
473 %__spec_install_post_compress_modules { \
474 %{!?no_install_post_compress_modules: __spec_install_post_compress_modules() { \
475         if [ -d $RPM_BUILD_ROOT/lib/modules ]; then \
476                 q=$(find $RPM_BUILD_ROOT/lib/modules -name '*o' -type f -print); \
477                 if [ "$q" ]; then \
478                         printf "Compress %d kernel modules..." $(echo "$q" | wc -l); \
479                         echo "$q" | xargs -r %{__gzip} -9nf; \
480                         echo "DONE"; \
481                         find $RPM_BUILD_ROOT/lib/modules -name '*o' -type l -printf "%p %l\n" | \
482                         while read a b; do ln -sf $b.gz $a.gz; rm -f $a; done; \
483                 fi; \
484         fi; \
485 }; __spec_install_post_compress_modules } }
486
487 # Remove common Perl files we don't package
488 %__spec_install_post_perl_clean {\
489 %{!?no_install_post_perl_clean: \
490 %{?pdir:rm -f $RPM_BUILD_ROOT{%{perl_archlib}/perllocal.pod,%{perl_vendorarch}/auto/%{pdir}%{?pnam:/%(echo %{pnam} | tr - /)}/.packlist}} \
491 } }
492
493 #-----------------------------------------------------------------
494 # Update GConf2 schemas
495 #
496 # Requires: GConf2
497 #
498 %gconf_schema_install() \
499         umask 022; \
500         GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" /usr/bin/gconftool-2 --makefile-install-rule /etc/gconf/schemas/%{?1}%{!?1:*.schemas} > /dev/null; \
501 %{nil}
502
503 %gconf_schema_uninstall() \
504 if [ $1 = 0 ]; then \
505         umask 022; \
506         GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" /usr/bin/gconftool-2 --makefile-uninstall-rule /etc/gconf/schemas/%{?1} > /dev/null \
507 fi; \
508 %{nil}
509
510 #-----------------------------------------------------------------
511 # Update desktop MIME database
512 # requires: desktop-file-utils
513 %update_desktop_database() {{ \
514         umask 022; \
515         /usr/bin/update-desktop-database -q; \
516 }}%{nil}
517
518 %update_desktop_database_post %update_desktop_database
519
520 %update_desktop_database_postun() {{ \
521 if [ "$1" = "0" ]; then \
522         %update_desktop_database; \
523 fi; \
524 }}%{nil}
525
526 #-----------------------------------------------------------------
527 # Update shared MIME info database
528 # requires: shared-mime-info
529 #
530 %update_mime_database() {{ \
531         umask 022; \
532         /usr/bin/update-mime-database %{_datadir}/mime; \
533 }}%{nil}
534
535 #-----------------------------------------------------------------
536 # Update icon cache
537 # requires: gtk+
538 #
539 %update_icon_cache() {{ \
540         umask 022; \
541         /usr/bin/gtk-update-icon-cache -qf %{_datadir}/icons/%1; \
542 }}%{nil}
543
544 #-----------------------------------------------------------------
545 # Update scrollkeeper database
546 # requires: scrollkeeper
547 #
548 %scrollkeeper_update_post() \
549         /usr/bin/scrollkeeper-update -q; \
550 %{nil}
551
552 %scrollkeeper_update_postun() \
553 if [ "$1" = "0" ]; then \
554         /usr/bin/scrollkeeper-update -q; \
555 fi; \
556 %{nil}
557
558 #-----------------------------------------------------------------
559 # post %install sequence:
560 # - autodeps exceptions
561 # - compress all man and info pages,
562 # - strip all ELF executables and ELF shared objects if not %debug.
563 # - compress kernel modules if any
564
565 ###################################################################
566 # Requires/Provides automation
567 # exceptions system by Jacek Konieczny <jajcus@pld.org.pl>
568 #
569 %__noautoreqfiles       %(sed -e s'/#.*//' /etc/rpm/noautoreqfiles)%{?_noautoreqfiles: %{_noautoreqfiles}}
570 %__noautoprovfiles      %(sed -e s'/#.*//' /etc/rpm/noautoprovfiles)%{?_noautoprovfiles: %{_noautoprovfiles}}
571 %__noautoreq            %(sed -e s'/#.*//' /etc/rpm/noautoreq)%{?_noautoreq: %{_noautoreq}}
572 %__noautoreqdep         %(sed -e s'/#.*//' /etc/rpm/noautoreqdep)%{?_noautoreqdep: %{_noautoreqdep}}
573 %__noautoprov           %(sed -e s'/#.*//' /etc/rpm/noautoprov)%{?_noautoprov: %{_noautoprov}}
574
575 #%_noautocompressdoc    %{nil}
576 #
577 %_missing_doc_files_terminate_build     1%{nil}
578 %_unpackaged_files_terminate_build      %{nil}
579 # (X)emacs support
580 %___emacs_lispdir_helper  -batch -q -eval '(while load-path (princ (concat (car load-path) "\\n")) (setq load-path (cdr load-path)))' 2> /dev/null|sed -n '/\\(.*\\/x\\?emacs\\/site-lisp\\)\\/\\?$/{s,,\\1,p;q;}'
581 %_emacs_lispdir %{expand:%%global _emacs_lispdir %(Z=$(emacs %___emacs_lispdir_helper); echo ${Z:-ERROR})}%_emacs_lispdir
582 %_xemacs_lispdir %{expand:%%global _xemacs_lispdir %(Z=$(xemacs %___emacs_lispdir_helper); echo ${Z:-ERROR})}%_xemacs_lispdir
583
584 %__php_provides %{nil}
585 %__php_requires %{nil}
586 %__perl_provides %{nil}
587 %__perl_requires %{nil}
588 %__mono_provides %{nil}
589 %__mono_requires %{nil}
590
591 # Perl specific macro definitions.
592 %perl_privlib           %{expand:%%global perl_privlib %(eval $(%{__perl} -V:installprivlib 2>/dev/null); echo ${installprivlib:-ERROR})}%perl_privlib
593 %perl_archlib           %{expand:%%global perl_archlib %(eval $(%{__perl} -V:installarchlib 2>/dev/null); echo ${installarchlib:-ERROR})}%perl_archlib
594 %perl_vendorlib         %{expand:%%global perl_vendorlib %(eval $(%{__perl} -V:installvendorlib 2>/dev/null); echo ${installvendorlib:-ERROR})}%perl_vendorlib
595 %perl_vendorarch        %{expand:%%global perl_vendorarch %(eval $(%{__perl} -V:installvendorarch 2>/dev/null); echo ${installvendorarch:-ERROR})}%perl_vendorarch
596 %perl_sitelib           %{expand:%%global perl_sitelib %(eval $(%{__perl} -V:installsitelib 2>/dev/null); echo ${installsitelib:-ERROR})}%perl_sitelib
597 %perl_sitearch          %{expand:%%global perl_sitearch %(eval $(%{__perl} -V:installsitearch 2>/dev/null); echo ${installsitearch:-ERROR})}%perl_sitearch
598
599 # Ruby
600 %__ruby                         /usr/bin/ruby
601 %ruby_archdir           %{expand:%%global ruby_archdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["archdir"]' 2>/dev/null || echo ERROR)}%ruby_archdir
602 %ruby_ridir                     %{expand:%%global ruby_ridir %(%{__ruby} -r rbconfig -e 'include Config; print File.join(CONFIG["datadir"], "ri", CONFIG["ruby_version"], "system")' 2>/dev/null || echo ERROR)}%ruby_ridir
603 %ruby_rubylibdir        %{expand:%%global ruby_rubylibdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["rubylibdir"]' 2>/dev/null || echo ERROR)}%ruby_rubylibdir
604 %ruby_vendorarchdir     %{expand:%%global ruby_vendorarchdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["vendorarchdir"]' 2>/dev/null || echo ERROR)}%ruby_vendorarchdir
605 %ruby_vendorlibdir      %{expand:%%global ruby_vendorlibdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["vendorlibdir"]' 2>/dev/null || echo ERROR)}%ruby_vendorlibdir
606 %ruby_sitearchdir       %{expand:%%global ruby_sitearchdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["sitearchdir"]' 2>/dev/null || echo ERROR)}%ruby_sitearchdir
607 %ruby_sitelibdir        %{expand:%%global ruby_sitelibdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["sitelibdir"]' 2>/dev/null || echo ERROR)}%ruby_sitelibdir
608 %ruby_version           %{expand:%%global ruby_version %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["ruby_version"]' 2>/dev/null || echo ERROR)}%ruby_version
609 %ruby_ver_requires_eq   Requires:       ruby(ver) = %ruby_version
610 %ruby_mod_ver_requires_eq       Requires:       ruby-modules(ver) = %ruby_version
611
612 %php_pear_dir           /usr/share/pear
613 %php_extensiondir       %{expand:%%global php_extensiondir %(php-config --extension-dir 2>/dev/null || echo ERROR)}%php_extensiondir
614 %php_sysconfdir         %{expand:%%global php_sysconfdir %(php-config --sysconfdir 2>/dev/null || echo ERROR)}%php_sysconfdir
615 %php_includedir         %{expand:%%global php_includedir %(php-config --include-dir 2>/dev/null || echo ERROR)}%php_includedir
616
617 # extract php/zend api versions
618 %php_major_version              %{expand:%%global php_major_version %(awk '/#define PHP_MAJOR_VERSION/{print $3}' %{php_includedir}/main/php_version.h 2>/dev/null || echo ERROR)}%php_major_version
619 %php_api_version                %{expand:%%global php_api_version %(awk '/#define PHP_API_VERSION/{print $3}' %{php_includedir}/main/php.h 2>/dev/null || echo ERROR)}%php_api_version
620 %php_pdo_api_version    %{expand:%%global php_pdo_api_version %(awk '/#define PDO_DRIVER_API/{print $3}' %{php_includedir}/ext/pdo/php_pdo_driver.h 2>/dev/null || echo ERROR)}%php_pdo_api_version
621 %php_debug                              %{expand:%%global php_debug %(awk '/#define ZEND_DEBUG/{print $3}' %{php_includedir}/main/php_config.h 2>/dev/null || echo ERROR)}%php_debug
622 %zend_module_api                %{expand:%%global zend_module_api %(awk '/#define ZEND_MODULE_API_NO/{print $3}' %{php_includedir}/Zend/zend_modules.h 2>/dev/null || echo ERROR)}%zend_module_api
623 %zend_extension_api             %{expand:%%global zend_extension_api %(awk '/#define ZEND_EXTENSION_API_NO/{print $3}' %{php_includedir}/Zend/zend_extensions.h 2>/dev/null || echo ERROR)}%zend_extension_api
624 %zend_zts                               %{expand:%%global zend_zts %(Z=$(grep -sc '^#define ZTS 1' %{php_includedir}/main/php_config.h); echo ${Z:-ERROR})}%zend_zts
625
626 # helper macro
627 %__php_api_requires(v:) Requires: php%{-v*}(%{expand:%1}) = %{expand:%{%{!?2:%{1}}%{?2}}}
628
629 # macros for public use
630 # for php extensions (php-pecl)
631 %requires_php_extension %{__php_api_requires modules_api php_api_version} \
632 %{__php_api_requires zend_module_api} \
633 %{__php_api_requires -v %php_major_version debug php_debug} \
634 %{__php_api_requires -v %php_major_version thread-safety zend_zts}
635
636 # for zend extensions
637 %requires_zend_extension %{__php_api_requires zend_module_api} \
638 %{__php_api_requires zend_extension_api} \
639 %{__php_api_requires -v %php_major_version debug php_debug} \
640 %{__php_api_requires -v %php_major_version thread-safety zend_zts}
641
642 # for php pdo modules (php-pecl-PDO_*)
643 %requires_php_pdo_module %{__php_api_requires PDO_API php_pdo_api_version}
644
645 # for using PHP post scripts. for PHP >= 5.0
646 %php_webserver_restart \
647 [ ! -f /etc/apache/conf.d/??_mod_php.conf ] || %service -q apache restart \
648 [ ! -f /etc/httpd/conf.d/??_mod_php.conf ] || %service -q httpd restart \
649 if [ -f /etc/rc.d/init.d/php-fcgi ]; then \
650         PHP_FCGI_BINARY=; . /etc/sysconfig/php-fcgi 2>/dev/null \
651         if [[ ${PHP_FCGI_BINARY:-php.fcgi} = *php.fcgi* ]]; then \
652                 %service -q php-fcgi restart \
653         fi \
654 fi \
655 %{nil}
656
657 # for using php post scripts. for PHP >= 4.0 && PHP < 5.0
658 %php4_webserver_restart \
659 [ ! -f /etc/apache/conf.d/??_mod_php4.conf ] || %service -q apache restart \
660 [ ! -f /etc/httpd/conf.d/??_mod_php4.conf ] || %service -q httpd restart \
661 if [ -f /etc/rc.d/init.d/php-fcgi ]; then \
662         PHP_FCGI_BINARY=; . /etc/sysconfig/php-fcgi 2>/dev/null \
663         if [[ ${PHP_FCGI_BINARY:-php.fcgi} = *php4.fcgi* ]]; then \
664                 %service -q php-fcgi restart \
665         fi \
666 fi \
667 %{nil}
668
669
670 # X.org helper macros
671 %__xorg_abi_requires() Requires: xorg-xserver-server(%{expand:%1}-abi) = %{expand:%{%{!?2:%{1}}%{?2}}}
672 #
673 %xorg_xserver_ansic_abi         %{expand:%%global xorg_xserver_ansic_abi %(awk '/#define ABI_ANSIC_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_ansic_abi
674 %xorg_xserver_extension_abi     %{expand:%%global xorg_xserver_extension_abi %(awk '/#define ABI_EXTENSION_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_extension_abi
675 %xorg_xserver_font_abi          %{expand:%%global xorg_xserver_font_abi %(awk '/#define ABI_FONT_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null | echo ERROR)}%xorg_xserver_font_abi
676 %xorg_xserver_videodrv_abi      %{expand:%%global xorg_xserver_videodrv_abi %(awk '/#define ABI_VIDEODRV_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_videodrv_abi
677 %xorg_xserver_xinput_abi        %{expand:%%global xorg_xserver_xinput_abi %(awk '/#define ABI_XINPUT_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_xinput_abi
678
679 %requires_xorg_xserver_extension %{__xorg_abi_requires ansic xorg_xserver_ansic_abi} \
680 %{__xorg_abi_requires extension xorg_xserver_extension_abi}
681 %requires_xorg_xserver_xinput %{__xorg_abi_requires ansic xorg_xserver_ansic_abi} \
682 %{__xorg_abi_requires xinput xorg_xserver_xinput_abi}
683 %requires_xorg_xserver_font %{__xorg_abi_requires ansic xorg_xserver_ansic_abi} \
684 %{__xorg_abi_requires font xorg_xserver_font_abi}
685 %requires_xorg_xserver_videodrv %{__xorg_abi_requires ansic xorg_xserver_ansic_abi} \
686 %{__xorg_abi_requires videodrv xorg_xserver_videodrv_abi}
687
688 # Python specific macro definitions.
689 # python main version
690 %py_ver                 %{expand:%%global py_ver %(%{__python} -c "import sys; print sys.version[:3]" || echo ERROR)}%py_ver
691
692 # directories
693 %py_prefix              %{expand:%%global py_prefix %(%{__python} -c "import sys; print sys.prefix" || echo ERROR)}%py_prefix
694 %py_libdir              %{py_prefix}/%{_lib}/python%{py_ver}
695 %py_scriptdir   %{py_prefix}/share/python%{py_ver}
696 %py_incdir              /usr/include/python%{py_ver}
697 %py_sitedir             %{py_libdir}/site-packages
698 %py_sitescriptdir %{py_scriptdir}/site-packages
699 %py_dyndir              %{py_libdir}/lib-dynload
700
701 # pure python modules compilation
702 %py_comp                python -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
703
704 %py_ocomp               python -O -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
705
706 # Software written in Python language require Python with main version
707 %pyrequires_eq() Requires:      %1
708
709 # Hardlink binary identical .pyc and .pyo files
710 # (idea by glen <at> pld-linux <dot> org)
711 %__spec_install_post_py_hardlink {\
712 %{!?no_install_post_py_hardlink: __spec_install_post_py_hardlink() { \
713 [ ! -d "$RPM_BUILD_ROOT" ] || find "$RPM_BUILD_ROOT" -name '*.pyc' | while read a; do \
714         b="${a%.pyc}.pyo"; \
715         if cmp -s "$a" "$b"; then \
716                 ln -f "$a" "$b"; \
717         fi; \
718 done \
719 }; __spec_install_post_py_hardlink } }
720
721 # remove python sources, so that check-files won't complain
722 # (idea by glen <at> pld-linux <dot> org)
723 %py_postclean() \
724 for d in %{py_sitescriptdir} %{py_sitedir} %*; do \
725  [ ! -d "$RPM_BUILD_ROOT$d" ] || find "$RPM_BUILD_ROOT$d" -name '*.py' -print0 | xargs -0r -l512 rm;\
726 done \
727 %{nil}
728
729 # depmod macro
730 %depmod() { \
731 umask 022; \
732 if [ -e /boot/System.map-%1 ]; then \
733         /sbin/depmod -a -F /boot/System.map-%1 %1; \
734 else \
735         if [ -e /boot/System.map ]; then \
736                 /sbin/depmod -a -F /boot/System.map %1; \
737         else \
738                 /sbin/depmod -a %1; \
739         fi \
740 fi; \
741 }
742
743 # XMMS specific macros
744 %xmms_prefix                    %{expand:%%global xmms_prefix %(xmms-config --prefix 2>/dev/null || echo ERROR)}%xmms_prefix
745 %xmms_exec_prefix               %{expand:%%global xmms_exec_prefix %(xmms-config --exec-prefix 2>/dev/null || echo ERROR)}%xmms_exec_prefix
746 %xmms_version                   %{expand:%%global xmms_version %(xmms-config --version 2>/dev/null || echo ERROR)}%xmms_version
747 %xmms_datadir                   %{expand:%%global xmms_datadir %(xmms-config --data-dir 2>/dev/null || echo ERROR)}%xmms_datadir
748 %xmms_plugindir                 %{expand:%%global xmms_plugindir %(xmms-config --plugin-dir 2>/dev/null || echo ERROR)}%xmms_plugindir
749 %xmms_visualization_plugindir   %{expand:%%global xmms_visualization_plugindir %(xmms-config --visualization-plugin-dir 2>/dev/null || echo ERROR)}%xmms_visualization_plugindir
750 %xmms_input_plugindir           %{expand:%%global xmms_input_plugindir %(xmms-config --input-plugin-dir 2>/dev/null || echo ERROR)}%xmms_input_plugindir
751 %xmms_output_plugindir          %{expand:%%global xmms_output_plugindir %(xmms-config --output-plugin-dir 2>/dev/null || echo ERROR)}%xmms_output_plugindir
752 %xmms_effect_plugindir          %{expand:%%global xmms_effect_plugindir %(xmms-config --effect-plugin-dir 2>/dev/null || echo ERROR)}%xmms_effect_plugindir
753 %xmms_general_plugindir         %{expand:%%global xmms_general_plugindir %(xmms-config --general-plugin-dir 2>/dev/null || echo ERROR)}%xmms_general_plugindir
754
755 %_target_base_arch      %{expand:%%global _target_base_arch %(echo %{_target_cpu} | sed 's/i.86/i386/;s/athlon/i386/;s/pentium./i386/;s/amd64/x86_64/;s/ia32e/x86_64/')}%_target_base_arch
756
757 # user/group checking macros
758 #
759 # Usage:
760 #       %userremove myuser
761 #
762 %userremove     /usr/lib/rpm/user_group.sh user del
763 %groupremove    /usr/lib/rpm/user_group.sh group del
764 #
765 # Usage:
766 #       if %usertestrm myuser; then
767 #               /usr/sbin/userdel -r myuser
768 # Note:
769 #       use these macros only if you need to call userdel/groupdel with
770 #       a non-standard option or take an extra action; otherwise use the
771 #       %userremove/%groupremove macros
772 #
773 %usertestrm     /usr/lib/rpm/user_group.sh user testrm
774 %grouptestrm    /usr/lib/rpm/user_group.sh group testrm
775 # user group membership management macros
776 #
777 # Usage:
778 #       %addusertogroup myuser agroup
779 #
780 %addusertogroup /usr/lib/rpm/user_group.sh user addtogroup
781
782 # banner support (useful in {pre,post}{,un} and triggers)
783 #
784 # Usage:
785 #       %banner name [-a] [-e] [-n] [-tn] <<EOF
786 # the banner text, the banner text
787 # the banner text, and following line
788 #EOF
789 # You can use any form of here-document, <<'EOF' <<-EOT will do.
790 # NOTE: if your use "<<-EOF", then You can actually indent inside here-document.
791 #
792 # -a   - append to the banner
793 # -e   - send to stderr instead of stdout
794 # -n   - no show banner (overrides -t)
795 # -t   - show only, if RPM_SCRIPTVERBOSITY >= n; default n=5
796 #
797 # Tests:
798 # (rpm -E '%banner -e banner <<EOF'; echo -e 'hi\nEOF') > m; sh -x m
799 # rpm -E 'date | %banner -e banner' > m; sh -x m
800 #
801 %banner(aent:) ( \
802 RPM_SCRIPTVERBOSITY=5 \
803 [ -r /etc/sysconfig/rpm ] && . /etc/sysconfig/rpm \
804 if [ -x /usr/bin/banner.sh ]; then \
805         CMD="/usr/bin/banner.sh %{-e:--stderr} %{!-n:$([ $RPM_SCRIPTVERBOSITY -ge %{-t:%{-t*}}%{!-t:5} ] && echo -s)} %{!-a:-m}%{-a:-M} %1" \
806 else \
807         CMD="cat%{-e: >&2}" \
808 fi \
809 eval $CMD %{?2:%2}%{?3: %3}) \
810 %{nil}
811
812 # useradd/groupadd macros
813 # Author: Elan Ruusamäe <glen@pld-linux.org>
814 #
815 # Usage:
816 #   %useradd [-P package] [-u uid] [-d home_dir] [-s shell] [-c comment]
817 #   [-g initial_group] [-G group[,...]] login
818 #
819 #  -u uid. REQUIRED
820 #  -g gid/group. REQUIRED
821 #  -s defaults to /bin/false
822 #  -d defaults to /usr/share/empty
823 #  -c No default
824 #  -r is accepted but ignored (it's always set)
825 #  -k skeleton dir. defaults to /usr/share/empty
826 # rpm specific flags
827 #  -P package name. defaults to %{name}
828 #
829 %useradd(c:d:e:f:g:G:Mmk:op:s:u:rP:) \
830 %{!-u:%{error:useradd: Required argument -u missing}} \
831 %{!-g:%{error:useradd: Required argument -g missing}} \
832 %{!?1:%{error:useradd: Required parameter login missing}} \
833 if [ -n "`/bin/id -u %{expand:%{%{#}}} 2>/dev/null`" ]; then \
834         if [ "`/bin/id -u %{expand:%{%{#}}}`" != "%{-u*}" ]; then \
835                 echo "Error: user %{expand:%{%{#}}} doesn't have uid=%{-u*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
836                 exit 1 \
837         fi \
838 else \
839         echo "Adding user %{expand:%{%{#}}} UID=%{-u*}." \
840         /usr/sbin/useradd \\\
841                 %{-m:-m -k %{-k*}%{!-k:/usr/share/empty}} \\\
842                 -u %{-u*} \\\
843                 -r \\\
844                 -d %{-d*}%{!-d:/usr/share/empty} \\\
845                 -s %{-s*}%{!-s:/bin/false} \\\
846                 %{-c:-c "%(set -- %{-c*} %{*}; echo $1)"}\\\
847                 -g %{-g*} \\\
848                 %{-M} \\\
849                 %{-G:-G %{-G*}} \\\
850                 %{expand:%{%{#}}} 1>&2 || exit $? \
851         [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i passwd || : \
852 fi;
853
854 # Usage:
855 #   %groupadd [-P package] [-g gid] group
856 #
857 # -g gid. REQUIRED
858 #
859 # Sample:
860 #   %groupadd -P %{name}-base -g %{gid} %{name}
861
862 %groupadd(g:P:rfo)      \
863 %{!-g:%{error:groupadd: Required argument -g missing}} \
864 %{!?1:%{error:groupadd: Required parameter group missing}} \
865 if [ -n "`/usr/bin/getgid %{1}`" ]; then \
866         if [ "`/usr/bin/getgid %{1}`" != "%{-g*}" ]; then \
867                 echo "Error: group %{1} doesn't have gid=%{-g*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
868                 exit 1 \
869         fi \
870 else \
871         echo "Adding group %{1} GID=%{-g*}." \
872         /usr/sbin/groupadd -g %{-g*} -r %{1} 1>&2 || exit $? \
873         [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i group || : \
874 fi;
875
876 # webapp macros
877 # Author: Elan Ruusamäe <glen@pld-linux.org>
878 #
879 # The config is installed/removed inside trigger, this means that you can any
880 # time install apache1/apache/lighttpd package and the configuration file is
881 # updated. if you don't need the config for various reason for specific
882 # webserver, just remove the symlink from config directory using webapp
883 # program. the trigger will not recreate the symlink on upgrades. In other
884 # words the config is linked to webserver config directory on first install of
885 # PACKAGE or WEBSERVER.
886 #
887 # Add package's webserver config to webserver webapps dir.
888 # Usage:
889 #   %webapp_register WEBSERVER WEBAPP
890 #
891 %webapp_register() \
892 %{?debug:set -x; echo "webapp_register: %{name}-%{version}-%{release} 1:[$1]; 2:[$2]"} \
893 if [ "$1" = "1" ] && [ "$2" = "1" ]; then\
894         /usr/sbin/webapp register %1 %2\
895 fi\
896 # reload webserver if the config symlink is there and skip reload if webserver is upgraded\
897 if [ -L /etc/%1/webapps.d/%(echo "%2" | tr '/' '-').conf ] && [ "$2" -lt "2" ]; then\
898         %{expand:%service -q %%1 reload}\
899 fi\
900 %{nil}
901
902 # Remove package's config from webserver webapps dir.
903 # Usage:
904 #   %webapp_register [-f] WEBSERVER WEBAPP
905 %webapp_unregister(f) \
906 %{?debug:set -x; echo "webapp_unregister: %{name}-%{version}-%{release}: 1:[$1]; 2:[$2]"} \
907 # remove link if either of the packages are gone \
908 if [ -n "%{-f:1}" ] || [ "$1" = "0" ] || [ "$2" = "0" ] && [ -L /etc/%1/webapps.d/%(echo "%2" | tr '/' '-').conf ]; then \
909         /usr/sbin/webapp unregister %1 %2\
910         %{expand:%service -q %%1 reload}\
911 fi \
912 %{nil}
913
914 # service macro.
915 # Author: Elan Ruusamäe <glen@pld-linux.org>
916 #
917 # calls usual service restart on package %post, but skips the restart if
918 # administrator has disabled automatic service restarts in either global
919 # /etc/sysconfig/rpm or per service /etc/sysconfig/SERVICE file.
920 #
921 # Usage:
922 #   %service [-q] SERVICE ACTION ["SERVICE NICE DESCRIPTION"]
923 #
924 #  -q be silent when service isn't started (for scriplets restaring other package's services)
925 #
926 %service(q) {{%(export quiet=%{-q:1}; /usr/lib/rpm/service_generator.sh %{*}) };}
927
928
929 # Java macros. based on jpackage macros.java
930 #
931 # Root directory where all Java VMs/SDK/JREs are installed.
932 %_jvmdir                %{_libdir}/jvm
933
934 # Root directory where all Java VMs/SDK/JREs expose their jars
935 %_jvmjardir             %{_libdir}/jvm-exports
936
937 # Root directory for all Java VM/SDK/JRE's private things.
938 %_jvmprivdir    %{_libdir}/jvm-private
939
940 # Root directory for all architecture dependent parts of Java VM/SDK/JRE's
941 %_jvmlibdir             %{_libdir}/jvm
942
943 # Root directory for all architecture independent parts of Java VM/SDK/JRE's
944 %_jvmdatadir    %{_datadir}/jvm
945
946 # Root directory for all configurations parts of Java VM/SDK/JRE's
947 %_jvmsysconfdir %{_sysconfdir}/jvm
948
949 # Root directory for all common architecture dependent parts of Java VM/SDK/JRE's
950 %_jvmcommonlibdir       %{_libdir}/jvm-common
951
952 # Root directory for all common architecture independent parts of Java VM/SDK/JRE's
953 %_jvmcommondatadir      %{_datadir}/jvm-common
954
955 # Root directory for all common configurations parts of Java VM/SDK/JRE's
956 %_jvmcommonsysconfdir   %{_sysconfdir}/jvm-common
957
958 # Directory where arch-specific (JNI) version-independent jars are installed.
959 %_jnidir                %{_libdir}/java
960
961 %java_home              %{expand:%%global java_home %([ -f %{_javadir}-utils/java-functions ] || { echo ERROR; exit 0; }; unset JAVA_HOME; . %{_javadir}-utils/java-functions; set_jvm; echo ${JAVA_HOME:-ERROR})}%java_home
962
963 %ant                    JAVA_HOME=%{java_home} ant
964 %jar                    %{java_home}/bin/jar
965 %java                   %{expand:%%global java %([ -f %{_javadir}-utils/java-functions ] || { echo ERROR; exit 0; }; unset JAVACMD; . %{_javadir}-utils/java-functions; set_javacmd; echo $JAVACMD)}%java
966 %javac                  %{java_home}/bin/javac
967 %javadoc                %{java_home}/bin/javadoc
968
969 %add_jvm_extension      JAVA_LIBDIR=%{buildroot}/%{_javadir}    %{_bindir}/jvmjar -l
970
971 %jpackage_script() \
972 install -d $RPM_BUILD_ROOT%{_bindir}\
973 cat > $RPM_BUILD_ROOT%{_bindir}/%5 << 'EOF' \
974 #!/bin/sh\
975 #\
976 # %{name} script\
977 # JPackage Project <http://www.jpackage.org/>\
978 \
979 # Source functions library\
980 . %{_javadir}-utils/java-functions\
981 \
982 # Source system prefs\
983 if [ -f %{_sysconfdir}/java/%{name}.conf ]; then\
984     . %{_sysconfdir}/java/%{name}.conf\
985 fi\
986 \
987 # Source user prefs\
988 if [ -f $HOME/.%{name}rc ]; then\
989     . $HOME/.%{name}rc\
990 fi\
991 \
992 # Configuration\
993 MAIN_CLASS=%1\
994 BASE_FLAGS=%2\
995 BASE_OPTIONS=%3\
996 BASE_JARS="%(echo %4 | tr ':' ' ')"\
997 \
998 # Set parameters\
999 set_jvm\
1000 set_classpath $BASE_JARS\
1001 set_flags $BASE_FLAGS\
1002 set_options $BASE_OPTIONS\
1003 \
1004 # Let's start\
1005 run "$@"\
1006 EOF
1007
1008 # jpackage 1.7
1009 # Directory for maven depmaps
1010 #
1011 %_mavendepmapdir /etc/maven
1012 %_mavendepmapfragdir /etc/maven/fragments
1013
1014 #
1015 # add_to_depmap adds an entry to the depmap. The arguments are:
1016 #
1017 # %1 the original groupid
1018 # %2 the original artifact id
1019 # %3 the version
1020 # %4 the new groupid
1021 # %5 the new artifactid
1022 #
1023
1024 %add_to_maven_depmap() \
1025 install -dm 755 $RPM_BUILD_ROOT/%{_mavendepmapfragdir}\
1026 cat >>$RPM_BUILD_ROOT/%{_mavendepmapfragdir}/%{name}<< EOF\
1027 <dependency>\
1028     <maven>\
1029         <groupId>%1</groupId>\
1030         <artifactId>%2</artifactId>\
1031         <version>%3</version>\
1032     </maven>\
1033     <jpp>\
1034         <groupId>%4</groupId>\
1035         <artifactId>%5</artifactId>\
1036         <version>%3</version>\
1037     </jpp>\
1038 </dependency>\
1039 \
1040 EOF\
1041 %{nil}
1042
1043 #==============================================================================
1044 #
1045 # update_maven_depmap updates the main maven depmap
1046 #
1047 %update_maven_depmap() \
1048 echo -e "<dependencies>\\n" > %{_mavendepmapdir}/maven2-depmap.xml\
1049 if [ -d %{_mavendepmapfragdir} ] && [ -n "`find %{_mavendepmapfragdir} -type f`" ]; then\
1050 cat %{_mavendepmapfragdir}/* >> %{_mavendepmapdir}/maven2-depmap.xml\
1051 fi\
1052 echo -e "</dependencies>\\n" >> %{_mavendepmapdir}/maven2-depmap.xml
1053
1054
1055 # PEAR install macros
1056 # Author: Elan Ruusamäe <glen@pld-linux.org>
1057 #
1058 # Usage:
1059 #       %%pear_package_setup [-a #] [-n FMT]
1060 #
1061 # -a #   - also unpack SOURCE#. for PEAR bootstrapping
1062 # -n FMT - create builddir with FMT, instead of default %%{_pearname}-%%{version}
1063 # -z     - unpack pear package and let pear use package.xml (not tarball) for install. for PEAR bootstrapping
1064 #
1065 # unpack PEAR package to %%{_builddir}/FMT. package is extracted with already
1066 # destination hierarchy. you should copy the tree to buildroot after
1067 # patching/reorganizing with %%pear_package_install.
1068 #
1069 # additionally BUILDROOT is stripped from files and files are converted to UNIX
1070 # line endings.
1071 #
1072 # the pear install process output is recorded to install.log, you should put it
1073 # to %%doc for later debug or just for information.
1074 #
1075 # additionally additional-packages.txt is produced if it was detected that the
1076 # package has optional dependencies. the file format is suitable of displaying
1077 # in %%post of a package. you should put this file to %%doc. noautocompressdoc is
1078 # automatically added for this file.
1079
1080
1081 # records install.log and transforms PEAR names to PLD Linux rpm package names.
1082 %__pear_install_log \
1083 tee install.log \
1084 # make post message of optional packages \
1085 grep 'can optionally use' install.log | sed -e 's,package "pear/,package "php-pear-,g;s,^pear/,php-pear-,' > optional-packages.txt \
1086 if [ -s optional-packages.txt ]; then \
1087         awk -F'"' '/use package/{print $2}' optional-packages.txt | sed -e "s,_,/,g;s,php-pear-, 'pear(,;s,$,.*)'," | tr -d '\\\n' > _noautoreq \
1088 else \
1089         rm -f optional-packages.txt \
1090 fi \
1091 %{nil}
1092
1093 # command invoking pear cli
1094 %__pear /usr/bin/pear
1095
1096 %pear_install(a:n:zD) \
1097 %__pear \\\
1098         -c pearrc \\\
1099         -d doc_dir=/docs \\\
1100         -d php_dir=%{php_pear_dir} \\\
1101         -d bin_dir=%{_bindir} \\\
1102         -d data_dir=%{php_pear_dir}/data \\\
1103         -d test_dir=%{php_pear_dir}/tests \\\
1104         install \\\
1105         --packagingroot=%{builddir} \\\
1106         --offline \\\
1107         --nodeps \\\
1108         %{-f:--force} \\\
1109         %{!-z:%{S:%{-a*}%{!-a:0}}}%{-z:$_P} > .install.log || { c=$?; cat .install.log; exit $c; }; \
1110 %{nil}
1111
1112 # The main macro.
1113 # using this macro will append optional-packages.txt to the nocompressdoc list
1114 # as it's displayed to user after package install. and adding additional gzip
1115 # dep is just waste ;)
1116 %pear_package_setup(a:n:zD) \
1117 %define srcdir %{-n*}%{!-n:%{_pearname}-%{version}} \
1118 %define builddir %{_builddir}/%{srcdir} \
1119 %setup -q -c -T %{-D:-D} -n %{srcdir} \
1120 %{-z:tar zxf %{S:0}; %{-a:tar zxf %{S:%{-a*}}}} \
1121 %{-z:_P=package2.xml; [ -f $_P ] || _P=package.xml; _N=%{srcdir}; mv $_P $_N; cd $_N} \
1122 %pear_install \
1123 %{-z:cd ..} \
1124 cat %{-z:$_N/}.install.log | %__pear_install_log \
1125 \
1126 # undos sources \
1127 find -type f -print0 | xargs -0 sed -i -e 's,\\r$,,' \
1128 %{!?_noautocompressdoc:%global _noautocompressdoc %{nil}}%{expand:%%global _noautocompressdoc %{_noautocompressdoc} optional-packages.txt} \
1129 %{!?_noautoprov:%global _noautoprov %{nil}}%{expand:%%global _noautoprov %{_noautoprov} 'pear(tests/.*)'} \
1130 %{nil}
1131
1132 # Copies exctracted PEAR package structure and PEAR registry to buildroot.
1133 # Author: Elan Ruusamäe <glen@pld-linux.org>
1134 %pear_package_install() \
1135 cp -a ./%{php_pear_dir}/{.registry,*} $RPM_BUILD_ROOT%{php_pear_dir} \
1136 find $RPM_BUILD_ROOT%{php_pear_dir} '(' -name '*~' -o -name '*.orig' ')' | xargs -r rm -v \
1137 # help the developer out a little: \
1138 if [ -f _noautoreq ]; then \
1139         echo "AutoReqdep detected:" \
1140         echo "_noautoreq $(cat _noautoreq)" \
1141 fi \
1142 %{nil}
1143
1144
1145 # Register OpenLDAP schema.
1146 # Author: Elan Ruusamäe <glen@pld-linux.org>
1147 #
1148 # Usage:
1149 #   %%openldap_schema_register [-d core,nis] %{schemadir}/horde.schema
1150 #
1151 #  -d specify dependant schemas, separated by comma
1152 #
1153 %openldap_schema_register(d:) \
1154 for schema in %*; do \
1155         if ! grep -q "$schema" /etc/openldap/slapd.conf; then \
1156                 %{__sed} -i -e " \
1157                         /^include.*local.schema/{ \
1158                                 iinclude\\t     $schema\
1159                         } \
1160                 " /etc/openldap/slapd.conf \
1161         fi \
1162 done \
1163 # enable dependant schemas \
1164 if [ "%{-d*}" ]; then \
1165         %{__sed} -i -e ' \
1166         /^#include.*\\(%(echo '%{-d*}' | %{__sed} -e 's/,/\\\\|/g')\\)\\.schema/{ \
1167                 s/^#// \
1168         }' /etc/openldap/slapd.conf \
1169 fi \
1170 %{nil}
1171
1172 # Unregister OpenLDAP schema.
1173 # Author: Elan Ruusamäe <glen@pld-linux.org>
1174 #
1175 # Usage:
1176 #   %%openldap_schema_unregister %{schemadir}/horde.schema
1177 #
1178 %openldap_schema_unregister() \
1179 for schema in %*; do \
1180         if grep -q "$schema" /etc/openldap/slapd.conf; then \
1181                 %{__sed} -i -e " \
1182                 /^include.*$(echo "$schema" | %{__sed} -e 's,/,\\\\/,g')/d \
1183                 # for symmetry it would be nice if we disable enabled schemas in post, \
1184                 # but we really can not do that, it would break something else. \
1185                 " /etc/openldap/slapd.conf \
1186         fi \
1187 done \
1188 %{nil}
1189
1190 %env_update [ ! -x /sbin/env-update ] || /sbin/env-update -u || :
1191
1192
1193 # Build modules for kernels 2.6
1194 # Author: Przemyslaw Iskra <sparky@pld-linux.org>
1195 #
1196 # Usage:
1197 #       %build_kernel_modules -m <modules> -C <directory>
1198 #
1199 #  remember that proper Makefile is still required
1200 # Options:
1201 #  -m <modules> (required) -- comma-separated list of modules to save,
1202 #               without .ko extension, may be placed in subdirectory
1203 #  -C <directory> -- change to <directory> before doing anything
1204 #  -p <arg>, -P <arg> -- arguments passeed to make scripts
1205 #  -c -- do not execute make clean
1206 #  <additional arguments> -- all additional arguments will be passed to
1207 #               make modules
1208 #
1209 # Additional patching supported via here document. Try:
1210 #       %build_kernel_modules -m module <<'EOF'
1211 #       your patch script here
1212 #       EOF
1213 # Don't use it unless patching depends on config options.
1214
1215 # Developer note: don't touch it unless you know how to handle '\'.
1216 # - \ in script expands to nothing
1217 # - \\\ in script expands to \
1218 # - \\\ inside definition expands to nothing
1219 # - \\\\\\\ inside definition expands to \
1220 # - in last line \ has to touch arguments so arguments passing
1221 #   in new lines (using \) will be supported
1222
1223 %build_kernel_modules(p:P:m:C:c)                                                                        \
1224 %{!?-m:%{error:%{0}: Required module name/list missing} exit 1}         \
1225                                                                                                                                         \
1226 %define Opts                                                                                                            \\\\\\\
1227 %if "%{_target_base_arch}" != "%{_arch}"                                                        \\\
1228         %if "%{_arch}" == "x86_64" && "%{_target_base_arch}" == "i386"  \\\
1229         CC="%{kgcc}" ARCH=%{_target_base_arch}                                                  \\\
1230         %else                                                                                                                   \\\
1231         ARCH=%{_target_base_arch} CROSS_COMPILE=%{_target_cpu}-pld-linux- \\\
1232         %endif                                                                                                                  \\\
1233 %else                                                                                                                           \\\
1234         CC="%{kgcc}"                                                                                                    \\\
1235 %endif                                                                                                                          \
1236 %define MakeOpts HOSTCC="%{kgcc}" SYSSRC=%{_kernelsrcdir} SYSOUT=$PWD/o \\\\\\\
1237                 O=$PWD/o %{?with_verbose:V=1} %{Opts}                                           \
1238                                                                                                                                         \
1239 %{?-C:cd %{-C*}}                                                                                                        \
1240 compile() {                                                                                                                     \
1241         L="<"; [[ '%{*}' != *$L$L* ]] || PATCH_SH="set -x -e;$(cat)"    \
1242         set -e -x                                                                                                               \
1243         local cfgs='%{?with_dist_kernel:%{?with_smp: smp}%{?with_up: up}}%{!?with_dist_kernel: nondist}' \
1244                                                                                                                                         \
1245 for cfg in ${cfgs:-dist}; do                                        \
1246         [ -r "%{_kernelsrcdir}/config-$cfg" ] || exit 1                                 \
1247                                                                                                                                         \
1248         rm -rf o                                                                                                                \
1249         install -d o/include/linux                                                                              \
1250         ln -sf %{_kernelsrcdir}/config-$cfg o/.config                                   \
1251         ln -sf %{_kernelsrcdir}/Module.symvers-$cfg o/Module.symvers    \
1252         ln -sf %{_kernelsrcdir}/include/linux/autoconf-$cfg.h o/include/linux/autoconf.h \
1253                                                                                                                                         \
1254         set +x                                                                                                                  \
1255         [ -z "$PATCH_SH" ] || echo "$PATCH_SH" | %__spec_build_shell    \
1256         set -x                                                                                                                  \
1257                                                                                                                                         \
1258         %if %{with dist_kernel}                                                                                 \
1259                 %{__make} -j1 -C %{_kernelsrcdir} prepare scripts                       \\\
1260                         %{-p*} %{-P*}                                                                                   \\\
1261                         %{MakeOpts}                                                                                             \
1262         %else                                                                                                                   \
1263                 install -d o/include/config                                                                     \
1264                 touch o/include/config/MARKER                                                           \
1265                 ln -sf %{_kernelsrcdir}/scripts o/scripts                                       \
1266         %endif                                                                                                                  \
1267                                                                                                                                         \
1268         %{!?-c:%{__make} -C %{_kernelsrcdir} clean                                              \\\
1269                 RCS_FIND_IGNORE="-name '*.ko' -o"                                                       \\\
1270                 ${1+"$@"}                                                                                                       \\\
1271                 M=$PWD %{MakeOpts}}                                                                                     \
1272                                                                                                                                         \
1273         %{__make} -C %{_kernelsrcdir} modules                                                   \\\
1274                 ${1+"$@"}                                                                                                       \\\
1275                 M=$PWD %{MakeOpts}                                                                                      \
1276                                                                                                                                         \
1277         for MODULE in {%{-m*},}; do                                                                             \
1278                 [ -z "${MODULE}" ] || mv ${MODULE}{,-$cfg}.ko                           \
1279         done                                                                                                                    \
1280 done                                                                                                                            \
1281 %{?-C:cd -}                                                                                                                     \
1282 }                                                                                                                                       \
1283 compile %{*}\
1284 %{nil}
1285
1286
1287 # Install kernel modules built by %build_kernel_modules
1288 # Author: Przemyslaw Iskra <sparky@pld-linux.org>
1289 #
1290 # Usage:
1291 #       %install_kernel_modules -m <modules> -d <directory>
1292 #
1293 # Options:
1294 #  -m <modules> (required) -- comma-separated list of modules to install,
1295 #               without .ko extension, may be placed in subdirectory
1296 #  -d <directory> (required) -- in what subdirectory modules should be
1297 #               installed (eg. misc, kernel/drivers/net)
1298 #  -s <suffix> -- suffix to use when installing modules, useful when module
1299 #               with same name exists in kernel already
1300 #  -n <file> -- name of modprobe config file to use (without .conf extension)
1301 #               for defining aliases, only useful with -s
1302
1303 %install_kernel_modules(m:d:s:n:)                                                                       \
1304 %{!?-m:%{error:%{0}: Required module name (-m) missing}exit 1}          \
1305 %{!?-d:%{error:%{0}: Required module directory missing}exit 1}          \
1306 %{?-n:%{!?-s:%{error:%{0}: Modprobe .conf file requires module suffix}exit 1}} \
1307                                                                                                                                         \
1308 %define KernelD $RPM_BUILD_ROOT/lib/modules/%{_kernel_ver}                      \
1309 %define ModprobeD $RPM_BUILD_ROOT%{_sysconfdir}/modprobe.d/%{_kernel_ver} \
1310                                                                                                                                         \
1311 local cfgs='%{?with_dist_kernel:%{?with_smp: smp}%{?with_up: up}}%{!?with_dist_kernel: nondist}' \
1312                                                                                                                                         \
1313 for MODULE in {%{-m*},}; do                                                                                     \
1314         [ -n "${MODULE}" ] || continue                                                                  \
1315         for cfg in ${cfgs:-dist}; do                                    \
1316                 [ "$cfg" = smp ] && suf=smp || suf=                                                     \
1317                 MNAME=${MODULE##*/}                                                                                     \
1318                 install -D ${MODULE}-$cfg.ko                                                            \\\
1319                         %{KernelD}$suf/%{-d*}/${MNAME}%{-s:-%{-s*}}.ko                  \
1320                 %{?-s:install -d %{ModprobeD}$suf                                                       \
1321                         echo "alias ${MNAME} ${MNAME}-%{-s*}"                                   \\\
1322                         >> %{ModprobeD}$suf/%{-n*}.conf}                                                \
1323         done                                                                                                                    \
1324 done                                                                                                                            \
1325 %{nil}
1326
1327 # patchset macros
1328 # Author: Elan Ruusamäe <glen@pld-linux.org>
1329 #
1330 # Usage:
1331 #   %patchset_source -f <seq(1) format> <start> [<end>]
1332 #   %patchset_patch <start> [<end>]
1333 #
1334 # If <end> is omited, it is assumed to be <start>.
1335 #
1336 # For example in preamble:
1337 #  %patchset_source -f ftp://ftp.vim.org/pub/editors/vim/patches/7.0/7.0.%03g 33 44
1338 # and in %prep:
1339 #  %patchset_patch 33 44
1340
1341 # generate SourceX urls from range START STOP
1342 # Format can be SINGLE format char of %e, %f, %g, see seq(1)
1343 # The sources start from 10000
1344 %patchset_source(f:b:) %(
1345         base=%{-b*}%{!-b*:10000};
1346         start=$(expr $base + %1);
1347         end=$(expr $base + %{?2}%{!?2:%{1}});
1348         # we need to call seq twice as it doesn't allow two formats
1349         seq -f 'Patch%g:' $start $end > %{tmpdir}/__ps1;
1350         seq -f '%{-f*}' %1 %{?2}%{!?2:%{1}} > %{tmpdir}/__ps2;
1351         paste %{tmpdir}/__ps{1,2};
1352         rm -f %{tmpdir}/__ps{1,2};
1353 ) \
1354 %{nil}
1355
1356 # apply sources from %patchset_source
1357 # -p specify -pX for %patch line
1358 # -b base offset: defaults to 10000
1359 %patchset_patch(f:p:b:) %(
1360         base=%{-b*}%{!-b*:10000};
1361         start=$(expr $base + %1);
1362         end=$(expr $base + %{?2}%{!?2:%{1}});
1363         echo ": patchset_patch %1%{?2: to %2}";
1364         seq -f 'patch%g %{-p*:-p%{-p*}}' $start $end | sed -e s,^,%%,;
1365 ) \
1366 %{nil}
1367
1368 # browser plugins v2
1369 # Author: Elan Ruusamäe <glen@pld-linux.org>
1370 #
1371 # Usage:
1372 #       %browser_plugins_add_browser <name> -p <plugindir>
1373 #
1374 #  <name> (required) -- name of the browser. usually %{name}.
1375 #  -p <plugindir> (required) -- in what directory browser searches for its plugins.
1376 #  -b -- default blacklists
1377 #  -a <arch> override arch
1378 #
1379 # Example:
1380 #   %browser_plugins_add_browser %{name} -p %{_firefoxdir}/plugins
1381
1382 %_browserpluginsconfdir         /etc/browser-plugins
1383 %_browserpluginsdir                     %{_libdir}/browser-plugins
1384 %update_browser_plugins         /usr/sbin/update-browser-plugins || :
1385
1386 %browser_plugins_add_browser(p:b:a:) \
1387         browser=%1.%{!-a:%{_target_base_arch}}%{-a*} \
1388         install -d $RPM_BUILD_ROOT%{_browserpluginsconfdir}/{blacklist,browsers}.d \
1389         ln -s %{-p*} $RPM_BUILD_ROOT%{_browserpluginsconfdir}/browsers.d/$browser \
1390         blacklist_file=$RPM_BUILD_ROOT%{_browserpluginsconfdir}/blacklist.d/$browser.blacklist \
1391         echo '# This file format is shell globs at base dir of plugindir' > $blacklist_file \
1392         %{-b:cat >> $blacklist_file %{-b*}} \
1393 %{nil}
1394
1395 # Helper for LUA.
1396 # split string separated by space into quoted list
1397 #
1398 # Author: Elan Ruusamäe <glen@pld-linux.org>
1399 #
1400 # %__lua_split /bin/sh /bin/pdksh -> "/bin/sh", "/bin/pdksh"
1401 %__lua_split() %(echo "%*" | awk '{for (i=1;i<=NF;i++) printf("\\"%%s\\"%%s", $i, i == NF ? "" : ", ")}')
1402
1403 # adjust /etc/shells by adding and removing shells from there
1404 # Author: Elan Ruusamäe <glen@pld-linux.org>
1405 #
1406 # Usage:
1407 #   %post       -p %add_etc_shells -p /bin/sh /bin/pdksh
1408 #   %preun      -p %remove_etc_shells -p /bin/sh /bin/pdksh
1409 #
1410 #  -p (optional) -- specifies that result is embeded %post script (prepends <lua> as first line)
1411
1412 %add_etc_shells(p) %{-p:<lua>}\
1413 t = {}\
1414 f = io.open("/etc/shells", "r")\
1415 if f then\
1416         for l in f:lines() do t[l]=l; end\
1417         f:close()\
1418 end\
1419 for _, s in ipairs({%{expand:%%__lua_split %*}}) do\
1420         if not t[s] then\
1421                 print("Adding "..s.." to /etc/shells")\
1422                 f = io.open("/etc/shells", "a"); f:write(s.."\\n"); f:close()\
1423         end\
1424 end\
1425 %{nil}
1426
1427 %remove_etc_shells(p) %{-p:<lua>}\
1428 %{-p:if arg[2] == 0 then}\
1429         t = {}\
1430         f = io.open("/etc/shells", "r")\
1431         if f then\
1432                 for l in f:lines() do t[l]=l; end\
1433                 f:close()\
1434         end\
1435         for _, l in pairs({%{expand:%%__lua_split %*}}) do\
1436                 print("Removing "..l.." from /etc/shells")\
1437                 t[l] = nil\
1438         end\
1439         s=""\
1440         for _, l in pairs(t) do\
1441                 s=s..l.."\\n"\
1442         end\
1443         io.open("/etc/shells", "w"):write(s)\
1444 %{-p:end} \
1445 %{nil}
1446
1447 # vim:ts=4 sw=4 noet syn=spec
This page took 0.284344 seconds and 4 git commands to generate.